<script setup lang="ts">
import jwt_decode from "jwt-decode";

definePageMeta({
  layout: "decorated",
});

const error = ref(false);
const errorMessage = ref("");

/**
 * Connecte l'utilisateur.
 * @param {Event} event l'évènement.
 */
async function connect(event: Event) {
  const { baseURL } = useRuntimeConfig().app;
  const { data: response, error: fetchError } = await useFetch(
    baseURL + "api/authentication",
    {
      method: "POST",
      headers: {
        "Content-Type": "application/json",
      },
      body: Object.fromEntries(new FormData(event.target)),
    }
  );

  if (fetchError.value === null) {
    const token: string = response.value.token;
    const decodedToken = jwt_decode(token);
    const tokenCookie = useCookie("aei-mobile-token", {
      maxAge: decodedToken.exp - decodedToken.iat,
      sameSite: "strict",
    });
    tokenCookie.value = token;
    window.location.href = baseURL;
  } else {
    errorMessage.value = "Identifiant ou mot de passe incorrect";
    error.value = fetchError.value = true;
  }
}

/**
 * Redirige l'utilisateur vers la page
 * de création de compte.
 */
function goToCreateAccount() {
  const { baseURL } = useRuntimeConfig().app;

  navigateTo(baseURL + "inscription");
}
</script>

<template>
  <main class="fr-pt-md-14v" role="main" id="content">
    <div class="fr-container fr-container--fluid fr-mb-md-14v">
      <div class="fr-grid-row fr-grid-row-gutters fr-grid-row--center">
        <div class="fr-col-12 fr-col-md-8 fr-col-lg-6">
          <div
            class="fr-container fr-background-alt--grey fr-md-0 fr-p-4v fr-py-md-14v"
          >
            <div class="fr-grid-row fr-grid-row-gutters fr-grid-row--center">
              <form id="login-1760" @submit.prevent="connect">
                <fieldset
                  class="fr-fieldset"
                  id="login-1760-fieldset"
                  aria-labelledby="login-1760-fieldset-legend login-1760-fieldset-messages"
                >
                  <legend
                    class="fr-fieldset__legend"
                    id="login-1760-fieldset-legend"
                  >
                    <h2>Se connecter avec son compte</h2>
                  </legend>

                  <div class="fr-fieldset__element">
                    <fieldset
                      class="fr-fieldset"
                      id="credentials"
                      aria-labelledby="credentials-messages"
                    >
                      <div class="fr-fieldset__element">
                        <span class="fr-hint-text"
                          >Sauf mention contraire, tous les champs sont
                          obligatoires.</span
                        >
                      </div>

                      <div class="fr-fieldset__element">
                        <div
                          class="fr-input-group"
                          :class="{ 'fr-input-group--error': error }"
                        >
                          <label class="fr-label" for="login-1757">
                            Identifiant
                          </label>

                          <input
                            class="fr-input"
                            autocomplete="login"
                            aria-required="true"
                            aria-describedby="login-1757-messages"
                            name="login"
                            id="login-1757"
                            type="text"
                          />
                        </div>
                      </div>

                      <div class="fr-fieldset__element">
                        <div
                          class="fr-password fr-input-group"
                          :class="{ 'fr-input-group--error': error }"
                          id="password-1758"
                        >
                          <label class="fr-label" for="password-1758-input">
                            Mot de passe
                          </label>

                          <div class="fr-input-wrap">
                            <input
                              class="fr-password__input fr-input"
                              aria-describedby="password-1758-input-messages"
                              aria-required="true"
                              name="password"
                              autocomplete="current-password"
                              id="password-1758-input"
                              type="password"
                            />
                          </div>
                          <!-- <div class="fr-password__checkbox fr-checkbox-group fr-checkbox-group--sm">
                            <input
                              aria-label="Afficher le mot de passe" id="password-1758-show" type="checkbox"
                              aria-describedby="password-1758-show-messages" />

                              <label class="fr-password__checkbox fr-label" for="password-1758-show">Afficher</label>

                            <div class="fr-messages-group" id="password-1758-show-messages" aria-live="polite"></div>
                          </div> -->

                          <!-- <p>
                            <a href="[À MODIFIER - url de la page de récupération]" class="fr-link">Mot de passe oublié ?</a>
                          </p> -->
                        </div>
                      </div>
                    </fieldset>
                  </div>

                  <!-- <div class="fr-fieldset__element">
                    <div class="fr-checkbox-group fr-checkbox-group--sm">
                      <input name="remember" id="remember-1759"
                        type="checkbox" aria-describedby="remember-1759-messages" />

                      <label class="fr-label" for="remember-1759">Se souvenir de moi</label>

                      <div class="fr-messages-group" id="remember-1759-messages" aria-live="polite"></div>
                    </div>
                  </div> -->

                  <div class="fr-input-group fr-input-group--error" v-if="error">
                    <p id="text-input-error-desc-error" class="fr-error-text fr-mt-0">
                      {{ errorMessage }}
                    </p>
                  </div>

                  <div class="fr-fieldset__element">
                    <ul class="fr-btns-group">
                      <li>
                        <button type="submit" class="fr-mt-2v fr-btn">
                          Se connecter
                        </button>
                      </li>
                    </ul>
                  </div>

                  <div
                    class="fr-messages-group"
                    id="login-1760-fieldset-messages"
                    aria-live="polite"
                  ></div>
                </fieldset>
              </form>
            </div>

            <hr />

            <h2>Vous n’avez pas de compte ?</h2>

            <ul class="fr-btns-group">
              <li>
                <button
                  class="fr-btn fr-btn--secondary"
                  @click="goToCreateAccount"
                >
                  Créer un compte
                </button>
              </li>
            </ul>
          </div>
        </div>
      </div>
    </div>
  </main>
</template>

<style scoped>
.fr-background-alt--grey {
  background-color: var(--background-alt-grey);
}
</style>
